"use strict";

exports.__esModule = true;
exports.analyse = analyse;
exports.transform = transform;
exports.transformFromAst = transformFromAst;

var _normalizeAst = require("../helpers/normalize-ast");

var _normalizeAst2 = _interopRequireDefault(_normalizeAst);

var _plugin = require("./plugin");

var _plugin2 = _interopRequireDefault(_plugin);

var _file = require("./file");

var _file2 = _interopRequireDefault(_file);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function analyse(code) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var visitor = arguments[2];

  opts.code = false;
  if (visitor) {
    opts.plugins = opts.plugins || [];
    opts.plugins.push(new _plugin2.default({ visitor: visitor }));
  }
  return transform(code, opts).metadata;
}

function transform(code, opts) {
  var file = new _file2.default(opts);
  return file.wrap(code, function () {
    file.addCode(code);
    file.parseCode(code);
    return file.transform();
  });
}

function transformFromAst(ast, code, opts) {
  ast = (0, _normalizeAst2.default)(ast);

  var file = new _file2.default(opts);
  return file.wrap(code, function () {
    file.addCode(code);
    file.addAst(ast);
    return file.transform();
  });
}